TACHYON
{

		CREATED 20121122.1800 - BB Riley, Underhill Center, VT  
		                        brianbr@wulfden.org
		BASEDON	code by Savage Circuits (spin) and Parallax (bs2)
}		
		
: QuadDecoder.fth	." Quadrature decoder driver"  ;

#P26	CONSTANT	A0			\  A output from encoder
#P27	CONSTANT	B0			\  B output from encoder
VARIABLE	oldBits
VARIABLE	newBits
VARIABLE	counter

: QE@	( -- ) IN@	A0 SHR 3 AND ;	\ get current state	

: QDEC@	( -- )					\ QuadratureDecoder
	A0 PININP	B0 PININP		\  Set encoder pins to inputs
	
	QE@		oldBits !			\  Pre-initialize oldBits (prevents 
								\       non-zero starting count)
	$10		counter !			\  initialize counter
  
	BEGIN
    	QE@	DUP newBits !		\  read encoder
		oldBits @
		<> IF					\ compare oldBits to newBits. Has it changed?  
			newBits @ 1 AND		\  determine direction and add or subtract from counter
			oldBits @ 1 SHR
			XOR 2* 1-
			counter @ + counter !
			
			newBits @ oldBits !  \ Update oldBits

			." counter =  " counter @ $840A .NUM CR
		THEN

	KEY? AND UNTIL				  \  this could be replaced by a pushbutton and reading
								  \   a pin
	;

END

